Heatsink = LibStub("AceAddon-3.0"):NewAddon("Heatsink", "AceEvent-3.0", "LibSink-2.0")
local addon = Heatsink
local db

local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Heatsink")
local candy = LibStub("LibCandyBar-3.0")
local media = LibStub("LibSharedMedia-3.0")

local itemSlots = {"Trinket0Slot", "Trinket1Slot", "Finger0Slot", "Finger1Slot", "HeadSlot"}
local guid, class, petguid
local bucket = {}

local _G = getfenv(0)
local CreateFrame = _G.CreateFrame
local GameFontNormal = _G.GameFontNormal
local GameTooltip = _G.GameTooltip
local GetContainerItemCooldown = _G.GetContainerItemCooldown
local GetContainerItemInfo = _G.GetContainerItemInfo
local GetContainerItemLink = _G.GetContainerItemLink
local GetContainerNumSlots = _G.GetContainerNumSlots
local GetInventoryItemCooldown = _G.GetInventoryItemCooldown
local GetInventoryItemLink = _G.GetInventoryItemLink
local GetInventoryItemTexture = _G.GetInventoryItemTexture
local GetInventorySlotInfo = _G.GetInventorySlotInfo
local GetItemInfo = _G.GetItemInfo
local GetRealZoneText = _G.GetRealZoneText
local GetSpellCooldown = _G.GetSpellCooldown
local GetSpellInfo = _G.GetSpellInfo
local GetTime = _G.GetTime
local IsActiveBattlefieldArena = _G.IsActiveBattlefieldArena
local LibStub = _G.LibStub
local UIParent = _G.UIParent
local UnitClass = _G.UnitClass
local UnitExists = _G.UnitExists
local UnitGUID = _G.UnitGUID
local ipairs = _G.ipairs
local pairs = _G.pairs
local select = _G.select
local string = _G.string
local tinsert = _G.table.insert
local tremove= _G.table.remove
local tsort = _G.table.sort
local tonumber = _G.tonumber
local tostring = _G.tostring
local unpack = _G.unpack
local wipe = _G.wipe

local BOOKTYPE_PET = _G.BOOKTYPE_PET
local BOOKTYPE_SPELL = _G.BOOKTYPE_SPELL
local STRING_SCHOOL_ARCANE = _G.STRING_SCHOOL_ARCANE
local STRING_SCHOOL_FIRE = _G.STRING_SCHOOL_FIRE
local STRING_SCHOOL_FROST = _G.STRING_SCHOOL_FROST
local STRING_SCHOOL_HOLY = _G.STRING_SCHOOL_HOLY
local STRING_SCHOOL_NATURE = _G.STRING_SCHOOL_NATURE
local STRING_SCHOOL_PHYSICAL = _G.STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_SHADOW = _G.STRING_SCHOOL_SHADOW
local RED_FONT_COLOR_CODE =_G.RED_FONT_COLOR_CODE
local FONT_COLOR_CODE_CLOSE = _G.FONT_COLOR_CODE_CLOSE

local defaults = {
	profile = {
		min = 3,
		max = 3600,
		growup = true,
		texture = "Blizzard",
		font = "ABF",
		fontsize = 10,
		width = 250,
		scale = 1,
		pos = {
			p = "CENTER",
			rp = "CENTER",
			x = 0,
			y = 0,
		},
		colors = {
			bg = { 0.5, 0.5, 0.5, 0.3 },
			text = { 1, 1, 1 },
			bar = { 0.25, 0.33, 0.68, 1 },
		},
		show = {
			spell = true,
			school = true,
			pet = true,
			item = true,
			inventory = true,
			proc = true,
		},
		sinkOptions = {},
	},
}

local spellsub = {
	[(GetSpellInfo(1499))] = L["Traps"], -- 1499 Freezing Trap
	[(GetSpellInfo(13795))] = L["Traps"], -- 13795 Immolation Trap
	[(GetSpellInfo(13809))] = L["Traps"], -- 13909 Immolation Trap
	[(GetSpellInfo(13813))] = L["Traps"], -- 13813 Explosive Trap
	[(GetSpellInfo(34600))] = L["Traps"], -- 34600 Snake Trap
	[(GetSpellInfo(8042))] = L["Shocks"], -- 8042 Earth Shock
	[(GetSpellInfo(8056))] = L["Shocks"], -- 8056 Frost Shock
	[(GetSpellInfo(8050))] = L["Shocks"], -- 8050 Flame Shock
	[(GetSpellInfo(53408))] = L["Judgement"], -- Judgement of Wisdom
	[(GetSpellInfo(20271))] = L["Judgement"], -- Judgement of Light
	[(GetSpellInfo(53407))] = L["Judgement"], -- Judgement of Justice
	[(GetSpellInfo(16979))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Bear, 49377 Feral Charge (Talent)
	[(GetSpellInfo(49376))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Cat,  49377 Feral Charge (Talent)
}

local inventorysub = {
	[L["Mana Jade"]] = L["Stones"],
	[L["Mana Ruby"]] = L["Stones"],
	[L["Mana Citrine"]] = L["Stones"],
	[L["Mana Agate"]] = L["Stones"],
	[L["Mana Emerald"]] = L["Stones"],
	[L["Healthstone$"]] = L["Stones"],
	[L["Potion"]] = L["Potions"],
	[L["Blue Ogre Brew Special"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew Special"]] = L["Potions"],  --Ogri'la
	[L["Blue Ogre Brew"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew"]] = L["Potions"],  --Ogri'la
	[L["Bottled Nethergon Energy"]] = L["Potions"],  --Tempest Keep
	[L["Bottled Nethergon Vapor"]] = L["Potions"],   --Tempest Keep
	[L["Cenarion Mana Salve"]] = L["Potions"],   --Cenarion Expedition
	[L["Cenarion Healing Salve"]] = L["Potions"],   --enarion Expedition
	[L["Major Healing Draught"]] = L["Potions"],   --PvP
	[L["Major Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Healing Draught"]] = L["Potions"],   --PvP
}

local spellchain = {
	[(GetSpellInfo(11958))] = { -- 11958 Cold Snap
		(GetSpellInfo(120)), -- 120 Cone of Cold
		(GetSpellInfo(122)), -- 122 Frost Nova
		(GetSpellInfo(614)), -- 6143 Frost Ward
		(GetSpellInfo(11426)), -- 11426 Ice Barrier
		(GetSpellInfo(45438)), -- 45438 Ice Block
		(GetSpellInfo(31687)), -- 31687 Summon Water Elemental
	},
	[(GetSpellInfo(14185))] = { -- 14185 Preparation
		(GetSpellInfo(14177)), -- 14177 Cold Blood
		(GetSpellInfo(1725)), -- 1725 Distract
		(GetSpellInfo(5277)), -- 5277 Evasion
		(GetSpellInfo(1966)), -- 1966 Feint
		(GetSpellInfo(1776)), -- 1776 Gouge
		(GetSpellInfo(1766)), -- 1766 Kick
		(GetSpellInfo(408)), -- 408 Kidney Shot
		(GetSpellInfo(2983)), -- 2983 Sprint
		(GetSpellInfo(1856)), -- 1856 Vanish
	},
	[(GetSpellInfo(23989))] = { -- 23989 Readiness
		(GetSpellInfo(19577)), -- 19577 Intimidation
		(GetSpellInfo(34026)), -- 34026 Kill Command
		(GetSpellInfo(1513)), -- 1513 Scare Beast
		(GetSpellInfo(19434)), -- 19434 Aimed Shot
		(GetSpellInfo(3044)), -- 3044 Arcane Shot
		(GetSpellInfo(5116)), -- 5116 Concussive Shot
		(GetSpellInfo(20736)), -- 20736 Distracting Shot
		(GetSpellInfo(1534)), -- 1534 Flare
		(GetSpellInfo(2643)), -- 2643 Multi-Shot
		(GetSpellInfo(3045)), -- 3045 Rapid Fire
		(GetSpellInfo(19801)), -- 19801 Tranquilizing Shot
		(GetSpellInfo(3034)), -- 3034 Viper Sting
		(GetSpellInfo(1510)), -- 1510 Volley
		(GetSpellInfo(19306)), -- 19306 Counterattack
		(GetSpellInfo(19263)), -- 19263 Deterrence
		(GetSpellInfo(781)), -- 781 Disengage
		(GetSpellInfo(13813)), -- 13813 Explosive Trap
		(GetSpellInfo(5384)), -- 5384 Feign Death
		(GetSpellInfo(1499)), -- 1499 Freezing Trap
		(GetSpellInfo(13809)), -- 13809 Frost Trap
		(GetSpellInfo(13795)), -- 13795 Immolation Trap
		(GetSpellInfo(34477)), -- 34477 Misdirection
		(GetSpellInfo(1495)), -- 1495 Mongoose Bite
		(GetSpellInfo(2973)), -- 2973 Raptor Strike
		(GetSpellInfo(34600)), -- 34600 Snake Trap
		(GetSpellInfo(19386)), -- 19386 Wyvern Sting
	},
}

local schools = {
	[1] = STRING_SCHOOL_PHYSICAL,
	[2] = STRING_SCHOOL_HOLY,
	[4] = STRING_SCHOOL_FIRE,
	[8] = STRING_SCHOOL_NATURE,
	[16] = STRING_SCHOOL_FROST,
	[32] = STRING_SCHOOL_SHADOW,
	[64] = STRING_SCHOOL_ARCANE,
}

local uninterruptible = {
	["WARLOCK"] = {
		[32] = (GetSpellInfo(686)), -- 686 Shadow Bolt 
		[4] = (GetSpellInfo(5676)), -- 5676 Searing Pain 
	},
	["MAGE"] = {
		[4] = (GetSpellInfo(133)), -- 133 Fireball
		[16] = (GetSpellInfo(116)), -- 116 Frostbolt
		[64] = (GetSpellInfo(5143)), -- 5343 Arcane Missiles 
	},
	["DRUID"] = {
		[8] = (GetSpellInfo(5185)), -- 5185 Healing Touch
	},
	["SHAMAN"] = {
		[1] = (GetSpellInfo(3738)), -- 3738 Wrath of Air Totem 
		[4] = (GetSpellInfo(8227)), -- 8227 Flametongue Totem
		[8] = (GetSpellInfo(403)), -- 403 Lightning Bolt
		[16] = (GetSpellInfo(5394)), -- 5394 Healing Stream Totem
	},
	["PRIEST"] = {
		[2] = (GetSpellInfo(585)), --585 Smite
		[32] = (GetSpellInfo(589)), -- 589 Shadow Word: Pain
	},
	["PALADIN"] = {
		[2] = (GetSpellInfo(635)), -- 635 Holy Light
	},
}

local proc = {
	[33648] = { -- 33648 Reflection of Torment
		time = 30,
		item = 40684, -- 40684 Mirror of Truth
	},
	[33953] = { -- 33953 Essence of Life
		item = 40685, -- 40685 The Egg of Mortal Essence
	},
	[49622] = { -- 49622 Bonus Mana Regen
		item = 37835, -- 37835 Je'tze's Bell
	},
	[55637] = { -- 55637 Lightweave
	},
	[58901] = { -- 58901 Tears of Anguish
		item = 43573, -- 43573 Tears of Bitter Anguish
	},
	[60063] = { -- 60063 Now is the Time!
		item = 40682, -- 40682 Sundial of the Exiled
	},
	[60436] = { -- 60436 Grim Toll
		item = 40256, -- 40256 Grim Toll
	},
	[60442] = { -- 60442 Bandit's Insignia
		item = 40371, -- 40371 Bandit's Insignia
	},
	[60490] = { -- 60490 Embrace of the Spider
		item = 39229, -- 39229 Embrace of the Spider
	},
	[60494] = { -- 60494 Dying Curse
		item = 40255, -- 40255 Dying Curse
	},
	[62114] = { -- 62114 Flow of Knowledge
		item = 44912, -- 44912 Flow of Knowledge
	},
	[62115] = { -- 62115 Strength of the Titans
		item = 44914, -- 44914 Anvil of Titans
	},
	[64742] = { -- 64742 Pandora's Plea
		item = 45490, -- 45490 Pandora's Plea
	},
	[4764] = { -- 4764 The General's Heart
		item = 45507, -- 45507 The General's Heart
	},
	[64792] = { -- 64792 Blood of the Old God
		item = 45522, -- 45522 Blood of the Old God
	},
	[65002] = { -- 65002 Bonus Mana Regen
		item = 45929, -- 45929 Sif's Rememberance
	},
	[65005] = { -- 65005 Alacrity of the Elements
		item = 45866, -- 45866 Elemental Focus Stone
	},
	[65013] = { -- 65013 Pyrite Infusion
		item = 45286, -- 45286 Pyrite Infuser
	},
	[65020] = { -- 65020 Mjolnir Runestone
		item = 45931, -- 45931 Mjolnir Runestone
	},
}

local options = {
	type = "group",
	args = {
		toggle = {
			type = "execute",
			name = L["Toggle anchor"],
			desc = L["Toggle the bar anchor frame"],
			func = function()
					addon:ToggleAnchor()
				end,
		},
		test = {
			type = "execute",
			name = L["Test"],
			desc = L["Test bars"],
			func = function()
					addon:RunTest()
				end,
		},
		output = addon:GetSinkAce3OptionsDataTable(),
		duration = {
			name = "Duration settings",
			desc = "Duration settings",
			type = "group",
			args = {
				min = {
					type = "input",
					name = L["Minimum duration"],
					desc = L["Minimum cooldown duration to display"],
					pattern = "%d+",
					get = function() return tostring(db.min) end,
					set = function(info, v) db.min = tonumber(v) end,
					order = 1,
				},
				max = {
					type = "input",
					name = L["Maximum duration"],
					desc = L["Maximum cooldown duration to display"],
					pattern = "%d+",
					get = function() return tostring(db.max) end,
					set = function(info, v) db.max = tonumber(v) end,
					order = 2, 
				},
			},
		},
		bars = {
			type = "group",
			name = L["Bar settings"],
			desc = L["Bar settings"],
			args = {
				growup = {
					type = "toggle",
					name = L["Grow upwards"],
					desc = L["Toggle bars grow upwards/downwards from anchor"],
					get = function () return db.growup end,
					set = function (info, v)
						db.growup = v
					end,
					order = 1,
				},
				scale = {
					type = "range",
					name = L["Scale"],
					desc = L["Set the scale of the bars"],
					get = function() return db.scale end,
					set = function(info, v)
							db.scale = v
						end,
					min = 0.1,
					max = 5,
					step = 0.01,
					isPercent = true,
					order = 4,
				},
				texture = {
					type = "select",
					dialogControl = 'LSM30_Statusbar',
					order = 6,
					name = L["Texture"],
					desc = L["Set the texture for the timer bars"],
					values = AceGUIWidgetLSMlists.statusbar,
					get = function() return db.texture end,
					set = function(i,v)
							db.texture = v
						end,
				},
			},
			order = 10,
		},
		show = {
			type = "group",
			name = L["Show cooldowns"],
			desc = L["Toggle showing cooldown types"],
			args = {
				spells = {
					type = "toggle",
					name = L["Enable player spells"],
					desc = L["Toggle showing player spells cooldowns"],
					get = function () return db.show.spell end,
					set = function (info, v) db.show.spell = v end,
					order = 10,
				},
				school = {
					type = "toggle",
					name = L["Show school"],
					desc = L["Spawns single bar if a school is locked out"],
					get = function () return db.show.school end,
					set = function (info, v) db.show.school = v end,
					disabled = function ()  return not db.show.school end,
					order = 11,
				},
				petspells = {
					type = "toggle",
					name = L["Pet spells"],
					desc = L["Toggle showing pet cooldowns"],
					get = function () return db.show.pet end,
					set = function (info, v) db.show.pet = v end,
					order = 20,
				},
				equipped = {
					type = "toggle",
					name = L["Equipped items"],
					desc = L["Toggle showing equipped items cooldowns"],
					get = function () return db.show.item end,
					set = function (info, v)
						db.show.item = v
						addon:ScanItems()
					end,
					order = 30,
				},
				bags = {
					type = "toggle",
					name = L["Inventory items"],
					desc = L["Toggle showing inventory items cooldowns"],
					get = function () return db.show.inventory end,
					set = function (info, v)
						db.show.inventory = v
						addon:ScanInventory()
					end,
					order = 40,
				},
				proc = {
					type = "toggle",
					name = L["Internal Cooldowns"],
					desc = L["Toggle showing item internal proc cooldowns"],
					get = function () return db.show.proc end,
					set = function (info, v) db.show.proc = v end,
					order = 40,
				},
			},
		},
	},
}

local function barStopped(event, bar)
	local a = bar:Get("anchor")
	if a and a.bars and a.bars[bar] then
		a.bars[bar] = nil
		addon:RearrangeBars(a)
		local text = bar.candyBarLabel:GetText()
		if text then addon:Pour(string.format("%s%s%s Ready Now!", RED_FONT_COLOR_CODE, text, FONT_COLOR_CODE_CLOSE)) end
	end
end

local function colorNormal() return unpack(db.colors.bar) end
local function colorText() return unpack(db.colors.text) end
local function colorBackground() return unpack(db.colors.bg) end

local function barSorter(a, b)
	return a.remaining > b.remaining and true or false
end

local function onDragHandleMouseDown(self) self:GetParent():StartSizing("BOTTOMRIGHT") end
local function onDragHandleMouseUp(self, button) self:GetParent():StopMovingOrSizing() end
local function onResize(self, width)
	db.width = width
	addon:RearrangeBars(self)
end

local function onDragStart(self) self:StartMoving() end

local function onDragStop(self)
	self:StopMovingOrSizing()
	local p, _, rp, x, y = self:GetPoint()
	db.pos.p = p
	db.pos.rp = rp
	db.pos.x = x
	db.pos.y = y
end

local function onControlEnter(self)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:AddLine(self.tooltipHeader)
	GameTooltip:AddLine(self.tooltipText, 1, 1, 1, 1)
	GameTooltip:Show()
end

local function onControlLeave() GameTooltip:Hide() end

function addon:OnInitialize()
	AceConfig:RegisterOptionsTable("Heatsink", options)
	self.db = LibStub("AceDB-3.0"):New("HeatsinkDB", defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", function() db = self.db.profile end)
	db = self.db.profile
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(addon.db)
	addon.optionFrame = AceConfigDialog:AddToBlizOptions("Heatsink", "Heatsink")
	self:SetSinkStorage(db.sinkOptions)
	candy.RegisterCallback(self, "LibCandyBar_Stop", barStopped)
	addon.anchor = addon:CreateAnchor("HeatsinkAnchor", "Heatsink")
end

function addon:OnEnable()
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("BAG_UPDATE_COOLDOWN")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN", "ScanBucket")
	self:RegisterEvent("PET_BAR_UPDATE_COOLDOWN", "ScanBucket")
	guid = UnitGUID("player")
	class = select(2, UnitClass("player"))
	if db.show.item then self:ScanItems() end
	if db.show.inventory then self:ScanInventory() end
end

function addon:OnDisable()
	self:UnregisterAllEvents()
end

function addon:RearrangeBars(anchor)
	local tmp = {} 
	for bar in pairs(anchor.bars) do
		tinsert(tmp, bar)
	end
	tsort(tmp, barSorter)
	local lastBar = nil
	for i, bar in ipairs(tmp) do
		bar:ClearAllPoints()
		if db.growup then
			bar:SetPoint("BOTTOMLEFT", lastBar or anchor, "TOPLEFT")
			bar:SetPoint("BOTTOMRIGHT", lastBar or anchor, "TOPRIGHT")
		else
			bar:SetPoint("TOPLEFT", lastBar or anchor, "BOTTOMLEFT")
			bar:SetPoint("TOPRIGHT", lastBar or anchor, "BOTTOMRIGHT")
		end
		lastBar = bar
	end
	wipe(tmp)
end

function addon:GetBar(text)
	local bar = nil
	for k in pairs(addon.anchor.bars) do
		if k.candyBarLabel:GetText() == text then
			bar = true
		end
	end
	return bar
end

function addon:StopBars(text)
	local bar = nil
	for k in pairs(addon.anchor.bars) do
		if (not text or k.candyBarLabel:GetText() == text) then
			k:Stop()
			bar = true
		end
	end
	return bar
end

function addon:Stop(text)
	local d = addon:StopBars(text)
	if d then addon:RearrangeBars(addon.anchor) end
end

function addon:CreateAnchor(frameName, title)
	local display = CreateFrame("Frame", frameName, UIParent)
	display:EnableMouse(true)
	display:SetMovable(true)
	display:SetResizable(true)
	display:RegisterForDrag("LeftButton")
	display:SetWidth(db.width or 200)
	display:SetHeight(20)
	display:SetMinResize(80, 20)
	display:SetMaxResize(1920, 20)
	display:ClearAllPoints()
	display:SetPoint(db.pos.p, UIParent, db.pos.rp, db.pos.x, db.pos.y)

	local bg = display:CreateTexture(nil, "PARENT")
	bg:SetAllPoints(display)
	bg:SetBlendMode("BLEND")
	bg:SetTexture(0, 0, 0, 0.3)

	local header = display:CreateFontString(nil, "OVERLAY")
	header:SetFontObject(GameFontNormal)
	header:SetText(title)
	header:SetAllPoints(display)
	header:SetJustifyH("CENTER")
	header:SetJustifyV("MIDDLE")

	local drag = CreateFrame("Frame", nil, display)
	drag:SetFrameLevel(display:GetFrameLevel() + 10)
	drag:SetWidth(16)
	drag:SetHeight(16)
	drag:SetPoint("BOTTOMRIGHT", display, -1, 1)
	drag:EnableMouse(true)
	drag:SetScript("OnMouseDown", onDragHandleMouseDown)
	drag:SetScript("OnMouseUp", onDragHandleMouseUp)
	drag:SetAlpha(0.5)

	local tex = drag:CreateTexture(nil, "BACKGROUND")
	tex:SetTexture("Interface\\AddOns\\Heatsink\\Textures\\draghandle")
	tex:SetWidth(16)
	tex:SetHeight(16)
	tex:SetBlendMode("ADD")
	tex:SetPoint("CENTER", drag)

	local test = CreateFrame("Button", nil, display)
	test:SetPoint("BOTTOMLEFT", display, "BOTTOMLEFT", 3, 3)
	test:SetHeight(14)
	test:SetWidth(14)
	test.tooltipHeader = L["Test"]
	test.tooltipText = L["Creates a new test bar"]
	test:SetScript("OnEnter", onControlEnter)
	test:SetScript("OnLeave", onControlLeave)
	test:SetScript("OnClick", function() addon:RunTest() end)
	test:SetNormalTexture("Interface\\AddOns\\Heatsink\\Textures\\test")

	local close = CreateFrame("Button", nil, display)
	close:SetPoint("BOTTOMLEFT", test, "BOTTOMRIGHT", 4, 0)
	close:SetHeight(14)
	close:SetWidth(14)
	close.tooltipHeader = L["Hide"]
	close.tooltipText = L["Hides the anchor"]
	close:SetScript("OnEnter", onControlEnter)
	close:SetScript("OnLeave", onControlLeave)
	close:SetScript("OnClick", function() addon:ToggleAnchor() end)
	close:SetNormalTexture("Interface\\AddOns\\Heatsink\\Textures\\close")

	display:SetScript("OnSizeChanged", onResize)
	display:SetScript("OnDragStart", onDragStart)
	display:SetScript("OnDragStop", onDragStop)
--	display:SetScript("OnMouseDown", displayOnMouseDown)
	display.bars = {}
	display:Hide()
	return display
end

function addon:ToggleAnchor()
	if addon.anchor:IsShown() then
		addon.anchor:Hide()
	else
		addon.anchor:Show()
	end
end

function addon:ResetAnchor()
	addon.anchor:ClearAllPoints()
	addon.anchor:SetPoint(db.pos.p, UIParent, db.pos.rp, db.pos.x, db.pos.y)
	addon.anchor:SetWidth(db.width)
end

function addon:RunTest()
	local _, _, icon = GetSpellInfo(37412)
	local start = GetTime()
	addon:StartBar("Hourglass Test 5", start, 5, icon, true)
	addon:StartBar("Hourglass Test 10", start, 10, icon, true)
	addon:StartBar("Hourglass Test 15", start, 15, icon, true)
end

function addon:StartBar(text, duration, icon, force)
	if not force and addon:GetBar(text) then return end
	addon:Stop(text)
	local bar = candy:New(media:Fetch("statusbar", db.texture), 200, 14)
	addon.anchor.bars[bar] = true
	bar.candyBarBackground:SetVertexColor(colorBackground())
	bar:Set("anchor", addon.anchor)
	bar:SetColor(colorNormal())
	bar.candyBarLabel:SetTextColor(colorText())
	bar:SetLabel(text)
	bar:SetDuration(duration)
	bar:SetTimeVisibility(true)
	bar:SetIcon(icon)
	bar:SetScale(db.scale)
	bar:Start()
	addon:RearrangeBars(bar:Get("anchor"))
end

function addon:ScanBucket()
	for index,id in pairs(bucket) do
		local name, rank, icon = GetSpellInfo(id)
		local start, duration, enabled = GetSpellCooldown(name)
		if duration >= db.min and duration <= db.max then
			local school = false
			if uninterruptible[class] then
				for k,v in pairs(uninterruptible[class]) do
					if v == name then 
						school = true			
						self:StartBar(L["%s School"]:format(k), duration, icon)
					end
				end
			end
			if not school then
				for k,v in pairs(spellsub) do
					if k == name then
						name =v
						break
					end
				end
				self:StartBar(name, duration, icon)
			end
			tremove(bucket,index)
		end
	end
end

function addon:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, oguid, _, oflag, dguid, dname, dflag, sid, sname, sschool, exid, exspell, exschool)
	if event == "SPELL_CAST_SUCCESS" then
		if db.show.spell and oguid == guid then
			if spellchain[sname] then
				for k,v in pairs(spellchain[sname]) do
					addon:Stop(v)
				end
			else
				tinsert(bucket, sid)
			end
		elseif db.show.pet and oguid == petguid then
			tinsert(bucket, sid)
		end
	elseif event == "SPELL_INTERRUPT" then
		if db.show.school and dguid == guid and uninterruptible[class] then
			tinsert(bucket, exid)
		end
	elseif event == "SPELL_AURA_APPLIED" then
		if db.show.proc and dguid == guid and proc[sid] then
			local name, icon
			local duration = proc[sid].time or 45
			if proc[sid].item then
				local _
				name, _, _, _, _, _, _, _, _, icon = GetItemInfo(proc[sid].item)
			else
				local _
				_, _, icon = GetSpellInfo(sid)
				name = sname
			end
			addon:StartBar(name, duration, icon)
		end
	end
end

function addon:ZONE_CHANGED_NEW_AREA()
	local zone = GetRealZoneText()
	if not zone then
		self:ScheduleTimer(self.ZONE_CHANGED_NEW_AREA, 5, self)
	elseif IsActiveBattlefieldArena() then
		addon:StopBars()
	end
end

function addon:UNIT_INVENTORY_CHANGED(event, unit)
	if unit == "player" then
		if db.show.item then self:ScanItems() end
		if db.show.inventory then self:ScanInventory() end
	end
end

function addon:BAG_UPDATE_COOLDOWN(event, container)
	if db.show.item then self:ScanItems() end
	if db.show.inventory then self:ScanInventory() end
end

function addon:ScanItems()
	for _, slotName in pairs(itemSlots) do
		local slotId = GetInventorySlotInfo(slotName)
		local start, duration, active = GetInventoryItemCooldown("player", slotId)
		if active == 1 and duration > db.min and duration <= db.max then
			local name = select(3, GetInventoryItemLink("player", slotId):find("Hitem[^|]+|h%[([^[]+)%]"))
			local icon = GetInventoryItemTexture("player", slotId)
			local force = false
			if slotName ~= "Trinket0Slot" and slotName ~= "Trinket1SLot" and duration <= 30 and addon:GetBar("name") then force = true end
			self:StartBar(name, duration, icon, force)
		end
	end
end

function addon:ScanInventory()
	for bag = 0,4 do
		local slots = GetContainerNumSlots(bag)
		for slot = 1,slots do
			local start, duration, active = GetContainerItemCooldown(bag,slot)
			if active == 1 and duration > db.min and duration <= db.max then
				local name = select(3, GetContainerItemLink(bag,slot):find("Hitem[^|]+|h%[([^[]+)%]"))
				local icon = GetContainerItemInfo(bag, slot)
				for pattern, replacement in pairs(inventorysub) do
					if (string.find(name, pattern)) then
						name = replacement
						break
					end
				end
				self:StartBar(name, duration, icon)
			end
		end
	end
end
